<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Lucky Dice</title>
      <!--Nhúng thư viện boostrap -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
    <style>
        .picture-cover{
            background-image: url("Images/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>
<body>
    <div class="container-fluid picture-cover">    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-sm-5">
                <div class="row  form-group">
                    <div class="col-sm-12" >
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row  form-group">
                    <div class="col-sm-4" >
                        <label> Username </label>
                    </div>
                    <div class="col-sm-8" >
                        <input class="form-control" type="text" id="username">
                    </div>
                </div>
                <div class="row  form-group">
                    <div class="col-sm-4" >
                        <label> Firstname </label>
                    </div>
                    <div class="col-sm-8" >
                        <input class="form-control" type="text" id="firstname">
                    </div>
                </div>
                <div class="row  form-group">
                    <div class="col-sm-4" >
                        <label> Lastname</label>
                    </div>
                    <div class="col-sm-8" >
                        <input class="form-control" type="text" id="lastname">
                    </div>
                </div>
            </div>
            <div class="col-sm-4 div-lavender ">
                <div class="row form-group">
                    <div class="col-sm-12 text-center" >
                        <button class="btn btn-warning" onclick="onNewDiceClick()">Ném new-dice</button>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-12 text-center" >
                        <img src="Images/dice.png" id="dice-img" class="img-thumbnail">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-12 text-center" >
                        <p id="p-thong-bao">Thông báo</p>
                    </div>
                </div>
            </div>
            <div class="col-sm-3 div-lavender">
                <div class="row  form-group">
                    <div class="col-sm-12 text-center" >
                        <p id="p-voucher">Voucher</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-12 text-center" >
                        <img id="present-img" src="Images/no-present.jpg" class="img-thumbnail">
                    </div>
                </div>
            </div>
        </div>
        <div class="row ing form-group text-center">
            <div class="col-sm-12 text-center" >
                <button class="btn btn-info"onclick= "onDiceHistory()">Dice History</button>
                <button class="btn btn-success">Voucher History</button>
                <button class="btn btn-success">Present History</button>
            </div>
        </div>
        <div class="row ">
            <div class="col-sm-12 text-center" >
                <table id="table-dice-history" class="table table-striped table-hover">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
      "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gEND_OF_ROW_COL = -1;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm thực hiện khi ấn nút new dice
    function onNewDiceClick(){
        var vPersonObj={
            username: "",
            firstname: "",
            lastname: ""
        }
        // B1 Thu thập dữ liệu
        thuThapDuLieu(vPersonObj);
        // B2: kiểm tra dữ liệu
        var vDuLieuHopLe = kiemTraDuLieu(vPersonObj);
        // B3: gọi Api 
        var vXmlHttpDice = new XMLHttpRequest();
        if (vDuLieuHopLe){
            goiApiNewDice(vPersonObj,vXmlHttpDice);
            vXmlHttpDice.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                console.log("Nút New-dice đã được ấn");
                // parsing to object
                var vResponse = JSON.parse(vXmlHttpDice.responseText);
                // hiển thị thông tin
                hienThiThongTin(vResponse);
                }
            }   
        }
    }
    // Hàm thực hiện khi ấn nút dice history
    function onDiceHistory(){
        var vPersonObj={
            username: "",
            firstname: "",
            lastname: ""
        }
        // B1 Thu thập dữ liệu
        thuThapDuLieu(vPersonObj);
        console.log(vPersonObj)
        // B2: kiểm tra dữ liệu
        var vDuLieuHopLe = kiemTraDuLieu(vPersonObj);
        // B3: gọi Api 
        var vXmlHttpDiceHistory = new XMLHttpRequest();
        if (vDuLieuHopLe){
            callApiDiceHistory(vPersonObj,vXmlHttpDiceHistory)
            vXmlHttpDiceHistory.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        var vDiceHistory = vXmlHttpDiceHistory.responseText;
                        hienThiDuLieu(vDiceHistory);
                    }
                }
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thu thập dữ liệu
    function thuThapDuLieu(paramObj){
        var vUsernameElement = document.getElementById("username");
        var vFirstNameElement = document.getElementById("firstname");
        var vLastNameElement = document.getElementById("lastname");
        paramObj.username = vUsernameElement.value;
        paramObj.firstname = vFirstNameElement.value;
        paramObj.lastname = vLastNameElement.value;
        return paramObj
    }
    // Hàm kiểm tra dữ liệu
    function kiemTraDuLieu(paramObj){
        if (paramObj.username == ""){
            alert("Chưa diền username");
            return false;
        } else if (paramObj.firstname == ""){
            alert("Chưa diền firstname");
            return false;
        } else if (paramObj.lastname == ""){
            alert("Chưa diền lastname");
            return false;
        }
        return true
    }
    // hàm gọi api khi bấm nút new dice
    function goiApiNewDice(paramUser,paramXmlHttp){
        paramXmlHttp.open("POST", gBASE_URL + "/dice", true);
        paramXmlHttp.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttp.send(JSON.stringify(paramUser));  //chuyển Json object sang string
    }
    // Hàm xử lý các sự kiện khi có được kết quả xúc xắc
    function hienThiThongTin(paramResponse){
        var vDiceReady = paramResponse.dice;
        changeDicePicture(vDiceReady);
        changeMessage(vDiceReady);
        var vVoucher = paramResponse.voucher;
        xuLyVoucher(vVoucher);
        var vPrize = paramResponse.prize;
        xuLyQuaTang(vPrize);
    }

    // Hàm xử lý ảnh dice
        function changeDicePicture(paramDice){
        var vImgDiceElement = document.getElementById("dice-img")
        if (paramDice == 1){
            vImgDiceElement.src = "Images/1.png";
            return;
        } else if (paramDice == 2 ){
            vImgDiceElement.src = "Images/2.png";
            return;
        } else if (paramDice == 3 ){
            vImgDiceElement.src = "Images/3.png";
            return;
        } else if (paramDice == 4 ){
            vImgDiceElement.src = "Images/4.png";
            return;
        } else if (paramDice == 5 ){
            vImgDiceElement.src = "Images/5.png";
            return;
        } else if (paramDice == 6 ){
            vImgDiceElement.src = "Images/6.png";
            return;
        }            
    }
    // Hàm hiển thị thông báo chúc mừng
    function changeMessage(paramDice){
        var vParagphElement = document.getElementById("p-thong-bao")
        if ( paramDice < 4 ){
            vParagphElement.innerHTML = "chúc bạn may mắn lần sau !!!";
        } else {
            vParagphElement.innerHTML = "chúc mừng bạn, hãy chơi tiếp lần nữa !!!";
        }
    }
    // Hàm hiển thị voucher nếu có
    function xuLyVoucher(paramVoucher){
        var vVoucherElement = document.getElementById("p-voucher");
        if (paramVoucher != null){
            vVoucherElement.innerHTML =
            "VOUCHER: " + "<br>"
            + paramVoucher.id + "<br>"
            + paramVoucher.phanTramGiamGia + "%";
        } else{
            vVoucherElement.innerHTML = "Không có voucher"
        }
    }
    // Hàm thiển thị quà tặng
    function xuLyQuaTang(paramPresent){
        var vImgPresnetElement = document.getElementById("present-img")
        if (paramPresent != null){
            if (paramPresent == "Sổ"){
                vImgPresnetElement.src = "Images/book.jpg";
                return;
            }  else if (paramPresent == "Áo mưa"){
                vImgPresnetElement.src = "Images/ao-mua.jpg";
                return;
            }  else if (paramPresent == "Xe máy"){
                vImgPresnetElement.src = "Images/xe-may.jpg";
                return;
            }  else if (paramPresent == "Mũ"){
                vImgPresnetElement.src = "Images/hat.jpg";
                return;
            }  else if (paramPresent == "Bút"){
                vImgPresnetElement.src = "Images/but.png";
                return;
            }  else if (paramPresent == "Ô tô"){
                vImgPresnetElement.src = "Images/car.jpg";
                return;
            }
        } else {
            vImgPresnetElement.src = "Images/no-present.jpg";
        }
    }
    // Call api gọi lịch sử dice
    function callApiDiceHistory(paramUser,paramXmlHttp){
        paramXmlHttp.open("GET", gBASE_URL + "/dice-history?username=" + paramUser.username, true);
        paramXmlHttp.send();
    }
    // Hiển thị bảng dữ liệu dice
    function hienThiDuLieu(paramHistory){
        var vDiceHistory = JSON.parse(paramHistory);
        var vHistoryTable = document.getElementById("table-dice-history");
        for (var bIndex = 0; bIndex < vDiceHistory.dices.length; bIndex++){
        var bNewRow = vHistoryTable.insertRow(gEND_OF_ROW_COL);
        var bGameCell = bNewRow.insertCell(0);
        var bDiceCell = bNewRow.insertCell(1);
        bGameCell.innerHTML  = bIndex + 1;
        bDiceCell.innerHTML  = vDiceHistory.dices[bIndex];
      }
    }


</script>
</html>